﻿using System;
using System.IO;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

namespace BMPViewer
{
    public partial class BMPViewerForm : Form
    {
        public PictureInfo NextForm;
        public PlateNumber Plate_Number_Form;
        Filter Filter_Image;
        Line_Detection Line_Detect;
        Car_Palte Car_Plate;

        public Bitmap BMPImg;

        FileStream ImageStream;
        BinaryReader ReadImage;

        public static int[] Feature;

        public static double[] Image_Hist;

        public static double[] Image_HistR;
        public static double[] Image_HistG;
        public static double[] Image_HistB;

        public static Color[,] Image_Data;
        public static Color[,] Detected_Lines;
        public static Color[,] Image_Contour;

        public int FileSize;
        public int Offset_Bitmap;
        public int Header_Size;
        public int image_Width;
        public int image_Height;

        public int Compression_Type;
        public int Image_Size;

        public int HorzResolution;
        public int VertResolution;

        public int Colors_Number;
        public int imp_Colors_Number;

        public short Num_of_Planes;
        public short Bit_Pixel_Number;

        public static string FileName;

        public BMPViewerForm()
        {
            InitializeComponent();
        }

        private void BMPViewerForm_Load(object sender, EventArgs e)
        {
            PictureBox.Visible = true;
            Separator3.Visible = false;
            ContourBox.Visible = false;
            ImageMenuItem.Visible = false;
            PictureHistogram.Visible = false;
            FileName = "";

            SaveMenuItem.Enabled = false;
            DetectedLines.Visible = false;
            InvertMenuItem.Enabled = false;
            FilterImageMenu.Enabled = false;
            ShowHistMenuItem.Enabled = false;
            BinarizeMenuItem.Enabled = false;
            GetPlateMenuItem.Enabled = false;
            ImageInfoMenuItem.Enabled = false;
            FeatureExMenuItem.Enabled = false;
            ExtraInfosMenuItem.Enabled = false;
            DetectLinesMenuItem.Enabled = false;
            ToGrayScaleMenuItem.Visible = false;
            ImageContourMenuItem.Enabled = false;
            MedianFilterMenuItem.Enabled = false;
            EqualizeHistMenuItem.Enabled = false;

            BMPImg = (Bitmap)Bitmap.FromFile("BMP.jpg");
            PictureBox.Location = new Point((this.Width - BMPImg.Width) / 2, (this.Height - BMPImg.Height) / 2);
            PictureBox.Size = new Size(BMPImg.Width, BMPImg.Height);
            PictureBox.Image = BMPImg;
        }

                                //////////////  Basic Functions   //////////////////

        private void OpenMenuItem_Click(object sender, EventArgs e)
        {
            ImageDialog.FileName = "";

            ImageDialog.ShowDialog();

            Draw();
        }

        private void Draw()
        {
            if (ImageDialog.FileName == "")
                return;
            
            ImageStream = new FileStream(ImageDialog.FileName, FileMode.Open);

            ReadImage = new BinaryReader(ImageStream);

            try
            {
                if (ReadImage.ReadChar().ToString() + ReadImage.ReadChar().ToString() == "BM")
                {

                    ReadImage.BaseStream.Seek(28, SeekOrigin.Begin);
                    short BitPixel = ReadImage.ReadInt16();

                    if (BitPixel != 8 && BitPixel != 24)
                    {
                        MessageBox.Show("The Image Type must be \"Gray Scale\" or \"RGB Color\"", "Error Message", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        ReadImage.Close();
                        ImageDialog.FileName = FileName;
                        return;
                    }

                    PictureBox.Visible = true;
                    ContourBox.Visible = false;
                    Separator3.Visible = false;
                    DetectedLines.Visible = false;
                    ImageMenuItem.Visible = false;
                    PictureHistogram.Visible = false;
                    GetPlateMenuItem.Enabled = false;
                    FeatureExMenuItem.Enabled = false;
                    ExtraInfosMenuItem.Enabled = false;
                    DetectLinesMenuItem.Enabled = false;
                    ToGrayScaleMenuItem.Visible = false;
                    ImageContourMenuItem.Enabled = false;

                    ReadImage.BaseStream.Seek(2, SeekOrigin.Begin);

                    FileName = ImageDialog.FileName;
                    FileSize = ReadImage.ReadInt32();

                    ReadImage.ReadInt16();
                    ReadImage.ReadInt16();

                    Offset_Bitmap = ReadImage.ReadInt32();
                    Header_Size = ReadImage.ReadInt32();
                    image_Width = ReadImage.ReadInt32();
                    image_Height = ReadImage.ReadInt32();
                    Num_of_Planes = ReadImage.ReadInt16();
                    Bit_Pixel_Number = ReadImage.ReadInt16();
                    Compression_Type = ReadImage.ReadInt32();
                    Image_Size = ReadImage.ReadInt32();

                    HorzResolution = ReadImage.ReadInt32();
                    VertResolution = ReadImage.ReadInt32();

                    Colors_Number = ReadImage.ReadInt32();
                    imp_Colors_Number = ReadImage.ReadInt32();

                    Image_Data = new Color[image_Height, image_Width];

                    ReadImage.BaseStream.Seek(Offset_Bitmap, SeekOrigin.Begin);

                    PictureBox.Location = new Point((this.Width - image_Width) / 2, (this.Height - 20 - image_Height) / 2);

                    BMPImg = new Bitmap(image_Width, image_Height);
                    PictureBox.Size = new Size(image_Width, image_Height);

                    for (int i = image_Height - 1; i >= 0; i--)
                    {
                        if (Bit_Pixel_Number == 24)
                        {
                            Hist_Color.Visible = true;
                            ToGrayScaleMenuItem.Visible = true;

                            int add = image_Width % 4;
                            for (int j = 0; j < image_Width; j++)
                            {
                                byte Pixel1 = ReadImage.ReadByte();
                                byte Pixel2 = ReadImage.ReadByte();
                                byte Pixel3 = ReadImage.ReadByte();
                                Color PixelColor = Image_Data[i, j] = Color.FromArgb(Pixel3, Pixel2, Pixel1);
                                BMPImg.SetPixel(j, i, PixelColor);
                            }
                            for (int j = 0; j < add; j++)
                            {
                                ReadImage.ReadByte();
                            }
                        }

                        else
                        {
                            Hist_Color.Visible = false;
                            ExtraInfosMenuItem.Enabled = true;
                            DetectLinesMenuItem.Enabled = true;

                            int add = image_Width % 4;
                            for (int j = 0; j < image_Width; j++)
                            {
                                byte Pixel = ReadImage.ReadByte();
                                Color PixelColor = Image_Data[i, j] = Color.FromArgb(Pixel, Pixel, Pixel);
                                BMPImg.SetPixel(j, i, PixelColor);
                            }
                            for (int j = 0; j < add; j++)
                            {
                                ReadImage.ReadByte();
                            }
                        }
                    }

                    PictureBox.Image = BMPImg;

                    Histogram();

                    PictureBox.Visible = true;

                    SaveMenuItem.Enabled = true;
                    InvertMenuItem.Enabled = true;
                    FilterImageMenu.Enabled = true;
                    ShowHistMenuItem.Enabled = true;
                    BinarizeMenuItem.Enabled = true;
                    ImageInfoMenuItem.Enabled = true;
                    MedianFilterMenuItem.Enabled = true;
                    EqualizeHistMenuItem.Enabled = true;

                    ReadImage.Close();
                }
            }

            catch
            {
                MessageBox.Show("The Image is not \"BMP Image\"", "Error Message", MessageBoxButtons.OK, MessageBoxIcon.Error);
                ReadImage.Close();
                ImageDialog.FileName = FileName;
                return;
            }
        }

        public void Draw_Changed()
        {
            BMPImg = new Bitmap(image_Width, image_Height);

            for (int i = 0; i < image_Height; i++)
            {
                for (int j = 0; j < image_Width; j++)
                {
                    Color PixelColor = Image_Data[i, j];
                    BMPImg.SetPixel(j, i, PixelColor);
                }
            }
            PictureBox.Image = BMPImg;

            if (Bit_Pixel_Number != 24)
                ToGrayScaleMenuItem.Visible = false;

            if (Bit_Pixel_Number != 8 && Bit_Pixel_Number != 24)
                BinarizeMenuItem.Enabled = false;

            if (PictureHistogram.Visible)
            {
                PictureHistogram.Visible = false;

                if (Bit_Pixel_Number == 24)
                    Hist_Color_SelectedIndexChanged(null, EventArgs.Empty);
                else
                    ShowHistMenuItem_Click(null, EventArgs.Empty);
            }
        }

        private void ToGrayScaleMenuItem_Click(object sender, EventArgs e)
        {
            ExtraInfosMenuItem.Enabled = true;

            double Pixel;
            for (int i = 0; i < image_Height; i++)
            {
                for (int j = 0; j < image_Width; j++)
                {
                    Pixel = 0.2989 * Convert.ToDouble(Image_Data[i, j].R.ToString()) + 0.5870 * Convert.ToDouble(Image_Data[i, j].G.ToString()) + 0.1140 * Convert.ToDouble(Image_Data[i, j].B.ToString());
                    Image_Data[i, j] = Color.FromArgb((int)Pixel, (int)Pixel, (int)Pixel);
                }
            }
            Bit_Pixel_Number = 8;

            Histogram();
            Draw_Changed();
        }

        private void PictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            string x_pos = (MousePosition.X - this.Location.X - PictureBox.Location.X - 3).ToString();
            string y_pos = (MousePosition.Y - this.Location.Y - PictureBox.Location.Y - 25).ToString();
            if (Convert.ToInt32(x_pos) >= 0 && Convert.ToInt32(x_pos) < image_Width && Convert.ToInt32(y_pos) >= 0 && Convert.ToInt32(y_pos) < image_Height)
            {
                X_Position.Text = "X Position : " + x_pos;
                Split1.Text = "\t" + " | " + "\t";
                Y_Position.Text = "Y Position : " + y_pos;
                Split2.Text = "\t" + " | " + "\t";
                Pixel_Color.Text = "Pixel Color : " + (Image_Data[Convert.ToInt32(y_pos), Convert.ToInt32(x_pos)]).Name;
            }

            else
            {
                X_Position.Text = "";
                Split1.Text = "";
                Y_Position.Text = "";
                Split2.Text = "";
                Pixel_Color.Text = "";
            }
        }

        private void ContourBox_MouseMove(object sender, MouseEventArgs e)
        {
            string x_pos = (MousePosition.X - this.Location.X - ContourBox.Location.X - 3).ToString();
            string y_pos = (MousePosition.Y - this.Location.Y - ContourBox.Location.Y - 25).ToString();
            if (Convert.ToInt32(x_pos) >= 0 && Convert.ToInt32(x_pos) < image_Width && Convert.ToInt32(y_pos) >= 0 && Convert.ToInt32(y_pos) < image_Height)
            {
                X_Position.Text = "X Position : " + x_pos;
                Split1.Text = "\t" + " | " + "\t";
                Y_Position.Text = "Y Position : " + y_pos;
                Split2.Text = "\t" + " | " + "\t";
                Pixel_Color.Text = "Pixel Color : " + (Image_Contour[Convert.ToInt32(y_pos), Convert.ToInt32(x_pos)]).Name;
            }

            else
            {
                X_Position.Text = "";
                Split1.Text = "";
                Y_Position.Text = "";
                Split2.Text = "";
                Pixel_Color.Text = "";
            }
        }

        private void DetectedLines_MouseMove(object sender, MouseEventArgs e)
        {
            string x_pos = (MousePosition.X - this.Location.X - DetectedLines.Location.X - 3).ToString();
            string y_pos = (MousePosition.Y - this.Location.Y - DetectedLines.Location.Y - 25).ToString();
            if (Convert.ToInt32(x_pos) >= 0 && Convert.ToInt32(x_pos) < image_Width && Convert.ToInt32(y_pos) >= 0 && Convert.ToInt32(y_pos) < image_Height)
            {
                X_Position.Text = "X Position : " + x_pos;
                Split1.Text = "\t" + " | " + "\t";
                Y_Position.Text = "Y Position : " + y_pos;
                Split2.Text = "\t" + " | " + "\t";
                Pixel_Color.Text = "Pixel Color : " + (Detected_Lines[Convert.ToInt32(y_pos), Convert.ToInt32(x_pos)]).Name;
            }

            else
            {
                X_Position.Text = "";
                Split1.Text = "";
                Y_Position.Text = "";
                Split2.Text = "";
                Pixel_Color.Text = "";
            }
        }
                                //////////////  Histogram   //////////////////

        private void ShowHistMenuItem_Click(object sender, EventArgs e)
        {
            if (Bit_Pixel_Number == 8)
            {
                Separator3.Visible = true;
                PictureBox.Visible = false;
                ContourBox.Visible = false;
                ImageMenuItem.Visible = true;
                DetectedLines.Visible = false;
                ShowHistMenuItem.Visible = false;

                X_Position.Text = "";
                Split1.Text = "";
                Y_Position.Text = "";
                Split2.Text = "";
                Pixel_Color.Text = "";

                PictureHistogram.Location = new Point((this.Width - 903) / 2, (this.Height - 630) / 2);
                PictureHistogram.Size = new Size(903, 610);

                Histogram();

                PictureHistogram.Visible = true;
            }

            else
            {
                Hist_Color.Text = "Histogram Color";
            }
        }

        private void Hist_Color_SelectedIndexChanged(object sender, EventArgs e)
        {
            Separator3.Visible = true;
            PictureBox.Visible = false;
            ContourBox.Visible = false;
            ImageMenuItem.Visible = true;
            DetectedLines.Visible = false;
            PictureHistogram.Visible = false;

            X_Position.Text = "";
            Split1.Text = "";
            Y_Position.Text = "";
            Split2.Text = "";
            Pixel_Color.Text = "";

            PictureHistogram.Location = new Point((this.Width - 903) / 2, (this.Height - 630) / 2);
            PictureHistogram.Size = new Size(903, 610);

            Histogram();

            PictureHistogram.Visible = true;
        }

        private void PictureHistogram_Paint(object sender, PaintEventArgs e)
        {
            Graphics MyGraphics = e.Graphics;
            Pen NewPen;

            NewPen = new Pen(Color.Black, 3);
            MyGraphics.DrawLine(NewPen, 0, 605, 905, 605);
            MyGraphics.DrawLine(NewPen, 0, 0, 0, 610);

            if (Bit_Pixel_Number == 24)
            {
                if (Hist_Color.SelectedIndex == 0)
                {
                    Draw_Hist(MyGraphics, Color.Red, Image_HistR);
                }

                else if (Hist_Color.SelectedIndex == 1)
                {
                    Draw_Hist(MyGraphics, Color.Green, Image_HistG);
                }

                else if (Hist_Color.SelectedIndex == 2)
                {
                    Draw_Hist(MyGraphics, Color.Blue, Image_HistB);
                }

                else
                {
                    Draw_Hist(MyGraphics, Color.Red, Image_HistR);
                    Draw_Hist(MyGraphics, Color.Green, Image_HistG);
                    Draw_Hist(MyGraphics, Color.Blue, Image_HistB);
                }
            }

            else
            {
                Draw_Hist(MyGraphics, Color.DarkSlateBlue, Image_Hist);
            }
        }

        private void Draw_Hist(Graphics MyGraphics, Color MyColor, double[] Image_Histogram)
        {
            Pen NewPen = new Pen(MyColor, 1);
            double Limit, max = Image_Histogram[0];
            for (int i = 1; i < 256; i++)
            {
                if (max < Image_Histogram[i])
                    max = Image_Histogram[i];
            }

            Limit = max / 600;

            float x1, x2 = 0, y1, y2 = 600;
            for (int i = 0; i < 256; i++)
            {
                x1 = (float)(5 + 3.48 * i);
                y1 = (float)(602 - Image_Histogram[i] / Limit);

                //MyGraphics.DrawLine(NewPen, x1, y1, x2, y2);

                x1 = (float)(5 + 3.48 * i);
                y1 = 602;
                x2 = x1;
                y2 = (float)(602 - Image_Histogram[i] / Limit);

                MyGraphics.DrawLine(NewPen, x1, y1, x2, y2);
            }
        }

        public void Histogram()
        {
            if (Bit_Pixel_Number == 24)
            {
                int Pixel;
                Image_HistR = new double[256];
                Image_HistG = new double[256];
                Image_HistB = new double[256];
                for (int i = 0; i < image_Height; i++)
                {
                    for (int j = 0; j < image_Width; j++)
                    {
                        Pixel = Convert.ToInt32(Image_Data[i, j].R.ToString());
                        Image_HistR[Pixel]++;

                        Pixel = Convert.ToInt32(Image_Data[i, j].G.ToString());
                        Image_HistG[Pixel]++;

                        Pixel = Convert.ToInt32(Image_Data[i, j].B.ToString());
                        Image_HistB[Pixel]++;
                    }
                }
            }

            else
            {
                Image_Hist = new double[256];
                for (int i = 0; i < image_Height; i++)
                {
                    for (int j = 0; j < image_Width; j++)
                    {
                        int Pixel = Convert.ToInt32(Image_Data[i, j].R.ToString());
                        Image_Hist[Pixel]++;
                    }
                }
            }
        }
                                //////////////  Equalizing   //////////////////

        private void EqualizeHistMenuItem_Click(object sender, EventArgs e)
        {
            Histogram();

            int[] newHistR = new int[256];
            int[] newHistG = new int[256];
            int[] newHistB = new int[256];

            int[] newHist = new int[256];
            if (Bit_Pixel_Number == 24)
            {
                double Total;
                for (int i = 0; i < 256; i++)
                {
                    Total = 0;

                    if (Image_HistR[i] != 0)
                    {
                        for (int j = i; j >= 0; j--)
                        {
                            Total += Image_HistR[j];
                        }
                        newHistR[i] = Convert.ToInt32(Total / (image_Height * image_Width) * 255);
                    }

                    Total = 0;

                    if (Image_HistG[i] != 0)
                    {
                        for (int j = i; j >= 0; j--)
                        {
                            Total += Image_HistG[j];
                        }
                        newHistG[i] = Convert.ToInt32(Total / (image_Height * image_Width) * 255);
                    }

                    Total = 0;

                    if (Image_HistB[i] != 0)
                    {
                        for (int j = i; j >= 0; j--)
                        {
                            Total += Image_HistB[j];
                        }
                        newHistB[i] = Convert.ToInt32(Total / (image_Height * image_Width) * 255);
                    }
                }
            }

            else
            {
                double Total;
                for (int i = 0; i < 256; i++)
                {
                    Total = 0;

                    if (Image_Hist[i] != 0)
                    {
                        for (int j = i; j >= 0; j--)
                        {
                            Total += Image_Hist[j];
                        }
                        newHist[i] = Convert.ToInt32(Total / (image_Height * image_Width) * 255);
                    }
                }
            }

            for (int i = 0; i < image_Height; i++)
            {
                for (int j = 0; j < image_Width; j++)
                {
                    int k;
                    if (Bit_Pixel_Number == 24)
                    {
                        int Pixel1, Pixel2, Pixel3;

                        k = Convert.ToInt32(Image_Data[i, j].R.ToString());
                        Pixel1 = newHistR[k];

                        k = Convert.ToInt32(Image_Data[i, j].G.ToString());
                        Pixel2 = newHistG[k];

                        k = Convert.ToInt32(Image_Data[i, j].B.ToString());
                        Pixel3 = newHistB[k];

                        Image_Data[i, j] = Color.FromArgb(Pixel1, Pixel2, Pixel3);
                    }

                    else
                    {
                        k = Convert.ToInt32(Image_Data[i, j].R.ToString());
                        Image_Data[i, j] = Color.FromArgb(newHist[k], newHist[k], newHist[k]);
                    }
                }
            }

            Draw_Changed();
            
            if (PictureHistogram.Visible)
            {
                PictureHistogram.Visible = false;

                if (Bit_Pixel_Number == 24)
                    Hist_Color_SelectedIndexChanged(null, EventArgs.Empty);
                else
                    ShowHistMenuItem_Click(null, EventArgs.Empty);
            }
        }
                                //////////////  Filtering   //////////////////
        
        private void FirstItem_Click(object sender, EventArgs e)
        {
            GetPlateMenuItem.Enabled = true;

            BMPViewerForm BMPImage = new BMPViewerForm();

            BMPImage.image_Width = this.image_Width;
            BMPImage.image_Height = this.image_Height;

            Filter_Image = new Filter(BMPImage, Image_Data);
            Image_Data = Filter_Image.Average1_Filter();

            Draw_Changed();
        }

        private void SecondItem_Click(object sender, EventArgs e)
        {
            GetPlateMenuItem.Enabled = true;

            BMPViewerForm BMPImage = new BMPViewerForm();

            BMPImage.image_Width = this.image_Width;
            BMPImage.image_Height = this.image_Height;

            Filter_Image = new Filter(BMPImage, Image_Data);
            Image_Data = Filter_Image.Average2_Filter();

            Draw_Changed();
        }

        private void MedianFilterMenuItem_Click(object sender, EventArgs e)
        {
            GetPlateMenuItem.Enabled = true;

            BMPViewerForm BMPImage = new BMPViewerForm();

            BMPImage.image_Width = this.image_Width;
            BMPImage.image_Height = this.image_Height;

            Filter_Image = new Filter(BMPImage, Image_Data);
            Image_Data = Filter_Image.Median_Filter();

            Draw_Changed();
        }
                                  //////////////  Invert Colors   /////////////////

        private void InvertMenuItem_Click(object sender, EventArgs e)
        {
            if (PictureBox.Visible)
            {
                for (int i = 0; i < image_Height; i++)
                {
                    for (int j = 0; j < image_Width; j++)
                    {
                        int k;
                        if (Bit_Pixel_Number == 24)
                        {
                            int Pixel1, Pixel2, Pixel3;

                            k = Convert.ToInt32(Image_Data[i, j].R.ToString());
                            Pixel1 = 255 - k;

                            k = Convert.ToInt32(Image_Data[i, j].G.ToString());
                            Pixel2 = 255 - k;

                            k = Convert.ToInt32(Image_Data[i, j].B.ToString());
                            Pixel3 = 255 - k;

                            Image_Data[i, j] = Color.FromArgb(Pixel1, Pixel2, Pixel3);
                        }

                        else if (Bit_Pixel_Number == 8)
                        {
                            k = Convert.ToInt32(Image_Data[i, j].R.ToString());
                            Image_Data[i, j] = Color.FromArgb(255 - k, 255 - k, 255 - k);
                        }

                        else
                        {
                            if (Image_Data[i, j] == Color.Black)
                                Image_Data[i, j] = Color.White;
                            else
                                Image_Data[i, j] = Color.Black;
                        }
                    }
                }
            }

            else if (ContourBox.Visible)
            {
                for (int i = 0; i < image_Height; i++)
                {
                    for (int j = 0; j < image_Width; j++)
                    {
                        if (Image_Contour[i, j] == Color.Black)
                            Image_Contour[i, j] = Color.White;
                        else
                            Image_Contour[i, j] = Color.Black;
                    }
                }
                ImageContourMenuItem_Click(null, EventArgs.Empty);
            }

            else if (DetectedLines.Visible)
            {
                for (int i = 0; i < image_Height; i++)
                {
                    for (int j = 0; j < image_Width; j++)
                    {
                        if (Detected_Lines[i, j] == Color.Black)
                            Detected_Lines[i, j] = Color.White;
                        else
                            Detected_Lines[i, j] = Color.Black;
                    }
                }
                DetectLinesMenuItem_Click(null, EventArgs.Empty);
            }

            else
            {
            }

            Draw_Changed();

            if (PictureHistogram.Visible)
            {
                PictureHistogram.Visible = false;

                if (Bit_Pixel_Number == 24)
                    Hist_Color_SelectedIndexChanged(null, EventArgs.Empty);
                else
                    ShowHistMenuItem_Click(null, EventArgs.Empty);
            }
        }
                                  //////////////  Thresholding   /////////////////

        private void BinarizeMenuItem_Click(object sender, EventArgs e)
        {
            Histogram();

            FeatureExMenuItem.Enabled = true;
            DetectLinesMenuItem.Enabled = true;
            ImageContourMenuItem.Enabled = true;

            BMPViewerForm BMPImage = new BMPViewerForm();

            BMPImage.image_Width = this.image_Width;
            BMPImage.image_Height = this.image_Height;
            BMPImage.Bit_Pixel_Number = this.Bit_Pixel_Number;

            Threshold Thresh = new Threshold(BMPImage, Image_Data);

            if (Bit_Pixel_Number == 24)
            {
                ToGrayScaleMenuItem_Click(null, EventArgs.Empty);
                Image_Data = Thresh.Thresholding(Image_Hist);
            }
            else
                Image_Data = Thresh.Thresholding(Image_Hist);

            
            Bit_Pixel_Number = 1;
            Draw_Changed();
            Calc_Contour();
            calc_DetectLines();
        }
                                //////////////  Image Contour   //////////////////

        private void Calc_Contour()
        {
            Feature = new int[8];
            Image_Contour = new Color[image_Height, image_Width];
            int move = 0, i = 0, j = 0;

            int[] X = new int[8] { -1, -1, 0, 1, 1, 1, 0, -1 };
            int[] Y = new int[8] { 0, -1, -1, -1, 0, 1, 1, 1 };
            int[] arr = new int[8] { 6, 6, 0, 0, 2, 2, 4, 4 };
            
            for (i = 0; i < image_Height; i++)
            {
                for (j = 0; j < image_Width; j++)
                {
                    if (Image_Data[i, j] == Color.Black)
                    {
                        break;
                    }
                }
                if (j != image_Width)
                    break;
            }

            if (i < image_Height && j < image_Width)
                Image_Contour[i, j] = Color.Black;

            int y = i, x = j, m = i + Y[move], n = j + X[move];

            do{
                for (int k = 0; k < 8; k++)
                {
                    if ((j + X[move] >= 0 && j + X[move] < image_Width) && (i + Y[move] >= 0 && i + Y[move] < image_Height))
                    {
                        if (Image_Data[(i + Y[move]), (j + X[move])] == Color.Black)
                        {
                            i = i + Y[move];
                            j = j + X[move];
                            if (Image_Contour[i, j] != Color.Black || (y == i && x == j && m == i + Y[arr[move]] && n == j + X[arr[move]]))
                            {
                                Image_Contour[i, j] = Color.Black;
                                Feature[move]++;
                            }
                            break;
                        }
                    }

                    move++;

                    if (move >= 8)
                        move %= 8;
                }

                move = arr[move];

            }while (y != i || x != j);
        }

        private void ImageContourMenuItem_Click(object sender, EventArgs e)
        {
            ContourBox.Size = PictureBox.Size;
            ContourBox.Location = PictureBox.Location;

            BMPImg = new Bitmap(image_Width, image_Height);

            for (int i = 0; i < image_Height; i++)
            {
                for (int j = 0; j < image_Width; j++)
                {
                    if (Image_Contour[i, j] == Color.Black)
                    {
                        BMPImg.SetPixel(j, i, Color.Black);
                    }

                    else
                    {
                        Image_Contour[i, j] = Color.White;
                        BMPImg.SetPixel(j, i, Color.White);
                    }
                }
            }
            ContourBox.Image = BMPImg;

            Separator3.Visible = true;
            ContourBox.Visible = true;
            PictureBox.Visible = false;
            ImageMenuItem.Visible = true;
            DetectedLines.Visible = false;
            PictureHistogram.Visible = false;
        }
                                //////////////  Saving Image   //////////////////

        private void SaveMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog.ShowDialog();
            if (SaveFileDialog.FileName != "")
            {
                if (PictureBox.Visible)
                    PictureBox.Image.Save(SaveFileDialog.FileName, System.Drawing.Imaging.ImageFormat.Bmp);

                else if (ContourBox.Visible)
                    ContourBox.Image.Save(SaveFileDialog.FileName, System.Drawing.Imaging.ImageFormat.Bmp);

                else if (PictureHistogram.Visible)
                    PictureHistogram.Image.Save(SaveFileDialog.FileName, System.Drawing.Imaging.ImageFormat.Bmp);

                else if (DetectedLines.Visible)
                    DetectedLines.Image.Save(SaveFileDialog.FileName, System.Drawing.Imaging.ImageFormat.Bmp);

                else
                    PictureHistogram.Image.Save(SaveFileDialog.FileName, System.Drawing.Imaging.ImageFormat.Bmp);
            }
        }
                                //////////////  View Image Info   //////////////////

        private void ImageInfoMenuItem_Click(object sender, EventArgs e)
        {
            BMPViewerForm BMPImage = new BMPViewerForm();

            BMPImage.FileSize = this.FileSize;
            BMPImage.Offset_Bitmap = this.Offset_Bitmap;
            BMPImage.Header_Size = this.Header_Size;
            BMPImage.image_Width = this.image_Width;
            BMPImage.image_Height = this.image_Height;
            BMPImage.Num_of_Planes = this.Num_of_Planes;

            BMPImage.Bit_Pixel_Number = this.Bit_Pixel_Number;
            BMPImage.Compression_Type = this.Compression_Type;
            BMPImage.Image_Size = this.Image_Size;
            BMPImage.HorzResolution = this.HorzResolution;
            BMPImage.VertResolution = this.VertResolution;

            BMPImage.Colors_Number = this.Colors_Number;
            BMPImage.imp_Colors_Number = this.imp_Colors_Number;

            NextForm = new PictureInfo(BMPImage);
            NextForm.Visible = true;
        }
                                    //////////////  Line Detection  //////////////////
        
        private void calc_DetectLines()
        {
            Detected_Lines = new Color[image_Height, image_Width];

            BMPViewerForm BMPImage = new BMPViewerForm();

            BMPImage.image_Width = this.image_Width;
            BMPImage.image_Height = this.image_Height;
            BMPImage.Bit_Pixel_Number = this.Bit_Pixel_Number;

            Line_Detect = new Line_Detection(BMPImage, Image_Data);

            int[,] new_Data = new int[BMPImage.image_Height, BMPImage.image_Width];

            for (int i = 0; i < image_Height; i++)
            {
                for (int j = 0; j < image_Width; j++)
                {
                    Detected_Lines[i, j] = Color.White;

                    if (Line_Detect.Hor_Data[i, j] >= 300)
                    {
                        Detected_Lines[i, j] = Color.Black;
                    }

                    if (Line_Detect.Ver_Data[i, j] >= 300)
                    {
                        Detected_Lines[i, j] = Color.Black;
                    }

                    if (Line_Detect.RS_Data[i, j] >= 450)
                    {
                        Detected_Lines[i, j] = Color.Black;
                    }

                    if (Line_Detect.LS_Data[i, j] >= 450)
                    {
                        Detected_Lines[i, j] = Color.Black;
                    }
                }
            }
        }

        private void DetectLinesMenuItem_Click(object sender, EventArgs e)
        {
            DetectedLines.Size = PictureBox.Size;
            DetectedLines.Location = PictureBox.Location;

            BMPImg = new Bitmap(image_Width, image_Height);

            for (int i = 0; i < image_Height; i++)
            {
                for (int j = 0; j < image_Width; j++)
                {
                    BMPImg.SetPixel(j, i, Detected_Lines[i, j]);
                }
            }
            DetectedLines.Image = BMPImg;
            
            Separator3.Visible = true;
            ContourBox.Visible = true;
            PictureBox.Visible = false;
            ContourBox.Visible = false;
            ImageMenuItem.Visible = true;
            DetectedLines.Visible = true;
            PictureHistogram.Visible = false;
        }
                                   //////////////  Get Car Plate //////////////////

        private void GetPlateMenuItem_Click(object sender, EventArgs e)
        {
            int ccount;
            int yl, yr, xu, xd;
            if (Bit_Pixel_Number == 24)
                ToGrayScaleMenuItem_Click(null, EventArgs.Empty);

            BMPViewerForm BMPImage = new BMPViewerForm();

            BMPImage.image_Width = this.image_Width;
            BMPImage.image_Height = this.image_Height;

            BMPImg = new Bitmap(image_Width, image_Height);

            for (int i = 0; i < image_Height; i++)
            {
                for (int j = 0; j < image_Width; j++)
                {
                    BMPImg.SetPixel(j, i, Image_Data[i, j]);
                }
            }

            Car_Plate = new Car_Palte(BMPImage, Image_Data);

            Image_Data = Car_Plate.Detect_Plate(out ccount, 67, out xu, out xd, out yl, out yr);

            Rectangle sourceRectangle = new Rectangle(yl, xu, yr - yl, xd - xu);
            Bitmap c_Bitmap = BMPImg.Clone(sourceRectangle, System.Drawing.Imaging.PixelFormat.DontCare);

            Plate_Number_Form = new PlateNumber(c_Bitmap);
            Plate_Number_Form.Visible = true;
            c_Bitmap.Save("Car Plate.bmp", System.Drawing.Imaging.ImageFormat.Bmp);

            

            Draw_Changed();
        }
                                    //////////////  Extra Info  //////////////////

        private double Mean()
        {
            double Total = 0;
            for (int i = 0; i < image_Height; i++)
            {
                for (int j = 0; j < image_Width; j++)
                {
                    Total += Convert.ToDouble(Image_Data[i, j].R.ToString());
                }
            }
            double Mean = Total / (image_Height * image_Width);

            return Mean;
        }

        private double Variance(double mean)
        {
            double Total = 0;
            for (int i = 0; i < image_Height; i++)
            {
                for (int j = 0; j < image_Width; j++)
                {
                    Total += Math.Pow((Convert.ToDouble(Image_Data[i, j].R.ToString()) - mean), 2);
                }
            }
            double Variance = Total / (image_Height * image_Width);

            return Variance;
        }

        private double calc_Moment(int i, int j)
        {
            double Total = 0;
            for (int k = 0; k < image_Height; k++)
            {
                for (int l = 0; l < image_Width; l++)
                {
                    Total += Math.Pow(k, i) * Math.Pow(l, j) * Convert.ToDouble(Image_Data[k, l].R.ToString());
                }
            }
            double Moment = Total;

            return Moment;
        }

        private double Central_Moment(int p, int q)
        {
            double Total = 0;
            double xd = calc_Moment(1, 0) / calc_Moment(0, 0);
            double yd = calc_Moment(0, 1) / calc_Moment(0, 0);
            for (int i = 0; i < image_Height; i++)
            {
                for (int j = 0; j < image_Width; j++)
                {
                    Total += Math.Pow((i - xd), p) * Math.Pow((j - yd), q) * Convert.ToDouble(Image_Data[i, j].R.ToString());
                }
            }
            double Moment = Total;

            return Moment;
        }

        private void MeanMenuItem_Click(object sender, EventArgs e)
        {
            double image_Mean = Mean();

            string Feature_Ex = "Image Mean\t:\t" + image_Mean.ToString() + "\n";

            MessageBox.Show(Feature_Ex, "Image Mean", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void VarianceMenuItem_Click(object sender, EventArgs e)
        {
            double image_Mean = Mean();
            double image_Variance = Variance(image_Mean);

            string Feature_Ex = "Image Variance\t:\t" + image_Variance.ToString();

            MessageBox.Show(Feature_Ex, "Image Variance", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void MomentMenuItem_Click(object sender, EventArgs e)
        {
            double[,] image_Moment = new double[4, 4];
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    image_Moment[i, j] = calc_Moment(i, j);
                }
            }

            string Feature_Ex = "Image Moment(0,0)\t:\t" + image_Moment[0, 0].ToString() + "\n"
                              + "Image Moment(0,1)\t:\t" + image_Moment[0, 1].ToString() + "\n"
                              + "Image Moment(0,2)\t:\t" + image_Moment[0, 2].ToString() + "\n"
                              + "Image Moment(0,3)\t:\t" + image_Moment[0, 3].ToString() + "\n"
                              + "Image Moment(1,0)\t:\t" + image_Moment[1, 0].ToString() + "\n"
                              + "Image Moment(1,1)\t:\t" + image_Moment[1, 1].ToString() + "\n"
                              + "Image Moment(1,2)\t:\t" + image_Moment[1, 2].ToString() + "\n"
                              + "Image Moment(1,3)\t:\t" + image_Moment[1, 3].ToString() + "\n"
                              + "Image Moment(2,0)\t:\t" + image_Moment[2, 0].ToString() + "\n"
                              + "Image Moment(2,1)\t:\t" + image_Moment[2, 1].ToString() + "\n"
                              + "Image Moment(2,2)\t:\t" + image_Moment[2, 2].ToString() + "\n"
                              + "Image Moment(2,3)\t:\t" + image_Moment[2, 3].ToString() + "\n"
                              + "Image Moment(3,1)\t:\t" + image_Moment[3, 0].ToString() + "\n"
                              + "Image Moment(3,0)\t:\t" + image_Moment[3, 1].ToString() + "\n"
                              + "Image Moment(3,2)\t:\t" + image_Moment[3, 2].ToString() + "\n"
                              + "Image Moment(3,3)\t:\t" + image_Moment[3, 3].ToString() + "\n";

            MessageBox.Show(Feature_Ex, "Moment", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void CentralMomentMenuItem_Click(object sender, EventArgs e)
        {
            double[,] Image_Central_Moment = new double[4, 4];
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    Image_Central_Moment[i, j] = Central_Moment(i, j);
                }
            }

            string Feature_Ex = "Central Moment(0,0)\t:\t" + Image_Central_Moment[0, 0].ToString() + "\n"
                              + "Central Moment(0,1)\t:\t" + Image_Central_Moment[0, 1].ToString() + "\n"
                              + "Central Moment(0,2)\t:\t" + Image_Central_Moment[0, 2].ToString() + "\n"
                              + "Central Moment(0,3)\t:\t" + Image_Central_Moment[0, 3].ToString() + "\n"
                              + "Central Moment(1,0)\t:\t" + Image_Central_Moment[1, 0].ToString() + "\n"
                              + "Central Moment(1,1)\t:\t" + Image_Central_Moment[1, 1].ToString() + "\n"
                              + "Central Moment(1,2)\t:\t" + Image_Central_Moment[1, 2].ToString() + "\n"
                              + "Central Moment(1,3)\t:\t" + Image_Central_Moment[1, 3].ToString() + "\n"
                              + "Central Moment(2,0)\t:\t" + Image_Central_Moment[2, 0].ToString() + "\n"
                              + "Central Moment(2,1)\t:\t" + Image_Central_Moment[2, 1].ToString() + "\n"
                              + "Central Moment(2,2)\t:\t" + Image_Central_Moment[2, 2].ToString() + "\n"
                              + "Central Moment(2,3)\t:\t" + Image_Central_Moment[2, 3].ToString() + "\n"
                              + "Central Moment(3,0)\t:\t" + Image_Central_Moment[3, 0].ToString() + "\n"
                              + "Central Moment(3,1)\t:\t" + Image_Central_Moment[3, 1].ToString() + "\n"
                              + "Central Moment(3,2)\t:\t" + Image_Central_Moment[3, 2].ToString() + "\n"
                              + "Central Moment(3,3)\t:\t" + Image_Central_Moment[3, 3].ToString() + "\n";

            MessageBox.Show(Feature_Ex, "Central Moment", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }
                                //////////////  Finishing  //////////////////


        private void featureExtractionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string Feature_Ex = "Up\t\t:\t"          + Feature[2].ToString() + "\n"
                              + "Down\t\t:\t"        + Feature[6].ToString() + "\n"
                              + "Left\t\t:\t"        + Feature[0].ToString() + "\n"
                              + "Right\t\t:\t"       + Feature[4].ToString() + "\n"
                              + "Up Left\t\t:\t"     + Feature[1].ToString() + "\n"
                              + "Up Right\t\t:\t"    + Feature[3].ToString() + "\n"
                              + "Down Left\t\t:\t"   + Feature[7].ToString() + "\n"
                              + "Down Right\t:\t"    + Feature[5].ToString() + "\n";

            MessageBox.Show(Feature_Ex, "Feature Extraction", MessageBoxButtons.OK);
        }

        private void ImageMenuItem_Click(object sender, EventArgs e)
        {
            PictureBox.Visible = true;
            ContourBox.Visible = false;
            DetectedLines.Visible = false;
            ImageMenuItem.Visible = false;
            ShowHistMenuItem.Visible = true;
            PictureHistogram.Visible = false;

            OpenMenuItem.Enabled = true;
            SaveMenuItem.Enabled = true;
        }

        private void AboutMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox Box = new AboutBox();
            Box.Visible = true;
        }

        private void ExitMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void BMPViewerForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            Application.Exit();
        }
    }
}
