﻿using System;
using System.IO;
using System.Data;
using System.Drawing;

namespace BMPViewer
{
    class Line_Detection
    {
        Color[,] Image_Data;
        BMPViewerForm BMPImage;

        public int[,] Hor_Data;
        public int[,] Ver_Data;
        public int[,] RS_Data;
        public int[,] LS_Data;

        public Line_Detection(BMPViewerForm BMP, Color[,] Data)
        {
            BMPImage = new BMPViewerForm();
            BMPImage = BMP;
            Image_Data = new Color[BMP.image_Height, BMP.image_Width];
            Image_Data = Data;

            int[,] Matrix1 = new int[,] { { -1, -1, -1 }, { 2, 2, 2 }, { -1, -1, -1 } };
            Hor_Data = Detect(Matrix1);

            int[,] Matrix2 = new int[,] { { -1, 2, -1 }, { -1, 2, -1 }, { -1, 2, -1 } };
            Ver_Data = Detect(Matrix2);

            int[,] Matrix3 = new int[,] { { -1, -1, 2 }, { -1, 2, -1 }, { 2, -1, -1 } };
            RS_Data = Detect(Matrix3);

            int[,] Matrix4 = new int[,] { { 2, -1, -1 }, { -1, 2, -1 }, { -1, -1, 2 } };
            LS_Data = Detect(Matrix4);
        }

        public int[,] Detect(int[,] Matrix)
        {
            int[,] Arr = new int[BMPImage.image_Height, BMPImage.image_Width];

            int Pixel;
            int Total;
            for (int i = 0; i < BMPImage.image_Height; i++)
            {
                for (int j = 0; j < BMPImage.image_Width; j++)
                {
                    Total = 0;
                    for (int k = 0; k < 3; k++)
                    {
                        for (int l = 0; l < 3; l++)
                        {
                            if (j - 1 + l < 0 || i - 1 + k < 0 || j - 1 + l >= BMPImage.image_Width || i - 1 + k >= BMPImage.image_Height)
                                Pixel = 0;
                            else
                            {
                                if (BMPImage.Bit_Pixel_Number == 8)
                                    Pixel = Convert.ToInt32(Image_Data[i - 1 + k, j - 1 + l].R.ToString());

                                else
                                {
                                    if (Image_Data[i - 1 + k, j - 1 + l] == Color.Black)
                                        Pixel = 0;
                                    else
                                        Pixel = 255;
                                }
                            }
                            Total += Pixel * Matrix[k, l];
                        }
                    }
                    Arr[i, j] = Total;
                }
            }
            return Arr;
        }
    }
}
