﻿using System;
using System.IO;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

namespace BMPViewer
{
    class Threshold
    {
        BMPViewerForm BMPImage;
        Color[,] Image_Data;

        public static double[] Image_Hist;

        public Threshold(BMPViewerForm BMP, Color[,] Data)
        {
            BMPImage = new BMPViewerForm();
            BMPImage = BMP;
            Image_Data = new Color[BMPImage.image_Height, BMPImage.image_Width];
            Image_Data = Data;
        }

        public Color[,] Thresholding(double[] Hist)
        {
            Image_Hist = new double[256];

            Image_Hist = Hist;

            int T = Threshold_Op();

            for (int i = 0; i < BMPImage.image_Height; i++)
            {
                for (int j = 0; j < BMPImage.image_Width; j++)
                {
                    if (Convert.ToInt32(Image_Data[i, j].R.ToString()) >= T)
                        Image_Data[i, j] = Color.White;
                    else
                        Image_Data[i, j] = Color.Black;
                }
            }
            MessageBox.Show("Optimal Thresholding T = " + T.ToString(),"Hint", MessageBoxButtons.OK, MessageBoxIcon.Information);
            return Image_Data;
        }

        private int Threshold_Op()
        {
            int T;
            double[] Variance_Arr = new double[256];
            double WB, WO, MeanB, MeanO, TotalB, TotalO;
            //double VarianceB, VarianceO;
            for (int i = 0; i < 256; i++)
            {
                WB = WO = MeanB = MeanO = TotalB = TotalO = 0;
                for (int j = 0; j < i; j++)
                {
                    WB += Image_Hist[j] / (BMPImage.image_Height * BMPImage.image_Width);
                    TotalB += Image_Hist[j];
                    MeanB += j * Image_Hist[j];
                }
                MeanB = (TotalB == 0)? 0 : MeanB / TotalB;

                for (int k = i; k < 256; k++)
                {
                    WO += Image_Hist[k] / (BMPImage.image_Height * BMPImage.image_Width);
                    TotalO += Image_Hist[k];
                    MeanO += k * Image_Hist[k];
                }
                MeanO = (TotalO == 0) ? 0 : MeanO / TotalO;

                Variance_Arr[i] = WB * WO * Math.Pow((MeanO - MeanB), 2);                
                
                //VarianceB = 0;
                //for (int j = 0; j < i; j++)
                //{
                //    VarianceB += Image_Hist[j] * Math.Pow((j - MeanB), 2);
                //}
                //VarianceB = (TotalB == 0) ? 0 : VarianceB / TotalB;

                //VarianceO = 0;
                //for (int k = i; k < 256; k++)
                //{
                //    VarianceO += Image_Hist[k] * Math.Pow((k - MeanO), 2);
                //}
                //VarianceO = (TotalO == 0) ? 0 : VarianceO / TotalO;

                //Variance_Arr[i] = WB * VarianceB + WO * VarianceO;
            }
            T = MaxIndex(Variance_Arr);
            return T;
        }

        private int MaxIndex(double[] Arr)
        {
            double Max = Arr[0];
            int index = 0;
            for (int i = 1; i < Arr.Length - 1; i++)
            {
                if (Arr[i] > Max)
                {
                    Max = Arr[i];
                    index = i;
                }
            }
            return index;
        }
    }
}
